class Addr {
  final String host;
  final int port;

  Addr(this.host, this.port);

  @override
  String toString() {
    return "$host:$port";
  }

  @override
  bool operator ==(Object other) =>
      other is Addr && other.port == port && other.host == host;

  static Addr fromString(String addr) {
    var colonIndex = addr.lastIndexOf(':');
    return Addr(addr.substring(0, colonIndex),
        int.parse(addr.substring(colonIndex + 1)));
  }

  @override
  int get hashCode => Object.hash(host, port);
}
