import 'package:yona_messenger/peer.dart';

class Msg {
  final Peer from;
  final String data;
  final MsgID id;

  @override
  String toString() {
    return "$id $from $data";
  }

  Msg(this.from, this.data, this.id);
}

class MsgID {
  final double _id;

  static MsgID now() {
    return fromDateTime(DateTime.now());
  }

  static fromDateTime(DateTime time) {
    return MsgID(time.toUtc().microsecondsSinceEpoch / 1000000);
  }

  static fromString(String str) {
    return MsgID(double.parse(str));
  }

  MsgID(this._id);

  @override
  String toString() {
    return _id.toString();
  }

  @override
  bool operator ==(Object other) => other is MsgID && other._id == _id;

  DateTime toDateTime() {
    return DateTime.fromMicrosecondsSinceEpoch((_id * 1000000).toInt());
  }

  @override
  int get hashCode => _id.hashCode;
}
